+++
+++

# Introduction

La suite forge est une collection d'outils pour automatiser des tâches en suivant les mises à jours sur un dépôt distant. `forgebuild` est un gestionnaire de tâches qui récupère (pull) les mises à jour sur un dépôt distant (git, mercurial), tandis que `forgehook` est un système de notification qui diffuse (push) les mises à jour reçues depuis un dépôt via des webhooks.

forgehook peut être branché à forgebuild pour déclencher des tâches automatiquement quand des mises à jour sont reçues, mais les deux outils peuvent être utilisés séparément et s'intégrer à tes propers outils. Si un outil se met en travers de ta route au lieu de te simplifier la vie, il s'agit d'un bug à corriger.

# Motivations

Ce projet a démarré car les distributions populaires de CI/CD (comme Drone CI ou Gitlab CI) sont des système très complexes, fortement intégrés dans un écosystème. La suite forge veut être plus portable et facile à intégrer dans ton propre écosystème.

Toutes ces plateformes de CI/CD considèrent que le dépôt lui-même doit contenir les tâches à exécuter, par exemple dans un fichier `.gitlab-ci.yml`. Ce modèle de développement vertical (top-down) est adapté à une organisation contrôlant l'ensemble de sa chaine logistique logicielle (supply chain), mais constitue une grande restriction à la participation de tierces personnes, ce qui impacte négativement les projets bénévoles.

La suite forge adopte une approche opposée, où tout le monde peut recevoir des mises à jour de dépôts distants, et exécuter les tâches qu'elle souhaite. Cela permet à n'importe qui, membre ou non de ton projet, de mettre en place de nouvelles suites de tests, benchmarks, ou autres intégrations. Les applications sont sans limite et devrait bénéficier à tes projets de plein de façons.

**N'attends pas la permission des mainteneurs, juste forge !**

# Principes

- **Sécurité par simplicité**: tout peut être compris et audité
- **Composabilité**: les outils ne doivent jamais se mettre en travers de ton chemin
- **Spécification**: plusieurs implémentations existent pour chaque outil, suivant les spécifications correspondantes

# Code De Conduite

Ce projet respecte les [principes opérationnelles ~fr](https://fr.tild3.org/).

# Securité

Bien que la suite forge vise la sécurité par la simplicité, ça peut mordre. N'utilise pas cet outil pour des projets sensibles, vu que nous n'avons aucun audit de sécurité.

Dans le futur, nous supporterons une chaine logistique sécurisée à travers des signatures PGP, inspirée par les [channel introductions](https://guix.gnu.org/en/blog/2020/securing-updates/) de GNU Guix.

# Licence

Tout est licencié sous licence GPLv3, sauf mention contraire. Le logo est une exception, je l'ai simplement trouvé sur Internet.
